/*
Original Hires grabber by enthusi/onslaught
multicolor support added by iAN CooG/HVSC
*/

#include <stdio.h>
#include <string.h>

#define FILENAMELENGTH 100
#define LINE for(i=0;i<79;i++)printf("-");printf("\n")

/* CHANGE THESE FOR OTHER VICE VERSIONS MAYBE */
#define VICOFFSET 0x48d
#define CIAOFFSET 0x16
#define ATTOFFSET 0x41

/* offset inside mbasic for $d020/21 values */
#define M_PATCH_D020 0x17
#define M_PATCH_D021 0x1c

int main (int argc, char **argv)
{
    unsigned char basic[] =
    { 0x01, 0x08, 0x13, 0x08, 0x00, 0x00, 0x9e, 0x32, 0x30, 0x36, 0x39,
      0x20, 0x45, 0x4e, 0x54, 0x48, 0x55, 0x53, 0x49, 0x00, 0x00, 0x00,
      0xa9, 0x00, 0x8d, 0x20, 0xd0, 0xa9, 0xff, 0x8d, 0x00, 0xdd, 0xa9,
      0x3b, 0x8d, 0x11, 0xd0, 0xa9, 0x38, 0x8d, 0x18, 0xd0, 0x4c, 0x29, 0x08
    };
    unsigned char mbasic[] =
    { 0x01, 0x08, 0x13, 0x08, 0x00, 0x00, 0x9e, 0x32,
      0x30, 0x36, 0x39, 0x20, 0x49, 0x41, 0x4e, 0x43,
      0x4f, 0x4f, 0x47, 0x00, 0x00, 0x00, 0xa9, 0x00,  /* <- 0x17 */
      0x8d, 0x20, 0xd0, 0xa9, 0x00, 0x8d, 0x21, 0xd0,  /* <- 0x1c */
      0xa9, 0xff, 0x8d, 0x00, 0xdd, 0xa9, 0x3b, 0x8d,
      0x11, 0xd0, 0xa9, 0x38, 0x8d, 0x18, 0xd0, 0xA9,
      0x18, 0x8D, 0x16, 0xD0, 0xA2, 0x00, 0xBD, 0x00,
      0x10, 0x9D, 0x00, 0xD8, 0xBD, 0x00, 0x11, 0x9D,
      0x00, 0xD9, 0xBD, 0x00, 0x12, 0x9D, 0x00, 0xDA,
      0xBD, 0x00, 0x13, 0x9D, 0x00, 0xDB, 0xE8, 0xD0,
      0xE5,0xF0,0xFE
    };

    FILE *vsf_file=NULL;
    FILE *map_file=NULL;
    FILE *col_file=NULL;
    FILE *prg_file=NULL;
    FILE *att_file=NULL;

    unsigned char value_d016, value_d018, value_d020, value_d021, value_dd00, byte, v1, v2, v3, v4;
    int i, bank, map, bitmap, file_end, pos_d018=0, pos_d800=0, pos_dd00=0,hmflag=0;

    char bitmap_name[FILENAMELENGTH];
    char colmap_name[FILENAMELENGTH];
    char attrib_name[FILENAMELENGTH];
    char prg_name[FILENAMELENGTH];

    if (argc < 2)
    {
        LINE;
        printf (
            "VSF HiRes/Multi grabber 2.0 by enthusi/onslaught & iAN CooG/HVSC\n"
            "Save VICE snapshot during display of any Bitmap.\n"
            "Original code by enthusi; Support for MultiColor by iAN CooG\n"
            "Syntax: '%s ViceSnapshotFile.vsf'.\n",
            argv[0]);
        LINE;
        return -1;
    }

    sprintf (bitmap_name, "%s.bitmap", argv[1]);
    sprintf (colmap_name, "%s.colmap", argv[1]);
    sprintf (attrib_name, "%s.attrib", argv[1]);
    sprintf (prg_name, "%s.prg", argv[1]);

    if (!(vsf_file = fopen (argv[1], "rb")))
    {
        printf ("Cant't open snapshot file '%s'!\n", argv[1]);
        return -1;
    }

    /* iAN: minimal sanity check */
    v1 = getc (vsf_file);
    v2 = getc (vsf_file);
    v3 = getc (vsf_file);
    v4 = getc (vsf_file);
    if (!((v1 == 'V') && (v2 == 'I') && (v3 == 'C') && (v4 == 'E')))
    {
        printf ("Not a VICE VSF file '%s'!\n", argv[1]);
        fclose(vsf_file);
        return -1;
    }

    if (!(map_file = fopen (bitmap_name, "wb")))
    {
        printf ("Cant't write bitmap file '%s'!\n", bitmap_name);
        fclose(vsf_file);
        return -1;
    }
    if (!(col_file = fopen (colmap_name, "wb")))
    {
        printf ("Cant't write colmap file '%s'!\n", colmap_name);
        fclose(vsf_file);
        fclose(map_file);
        return -1;
    }
    if (!(prg_file = fopen (prg_name, "wb")))
    {
        printf ("Cant't write PRG file '%s'!\n", prg_name);
        fclose(vsf_file);
        fclose(map_file);
        fclose(col_file);
        return -1;
    }

    fseek (vsf_file, 0, SEEK_END);
    file_end = ftell (vsf_file);

    for (i = 0; i < file_end; i++)
    {
        fseek (vsf_file, i, SEEK_SET);
        v1 = getc (vsf_file);
        v2 = getc (vsf_file);
        v3 = getc (vsf_file);
        v4 = getc (vsf_file);
        if ((v1 == 'V') && (v2 == 'I') && (v3 == 'C') && (v4 == '-'))
        {
            pos_d018 = i + VICOFFSET;
            pos_d800 = i + ATTOFFSET;
        }
        if ((v1 == 'C') && (v2 == 'I') && (v3 == 'A') && (v4 == '2'))
            pos_dd00 = i + CIAOFFSET;
    }

    fseek (vsf_file, pos_dd00, SEEK_SET);
    value_dd00 = getc (vsf_file);

    fseek (vsf_file, pos_d018-2, SEEK_SET);
    value_d016 = getc (vsf_file);
    hmflag = (value_d016&0x10)>>4; /* 0 hires, 1 multi */

    fseek (vsf_file, pos_d018, SEEK_SET);
    value_d018 = getc (vsf_file);

    fseek (vsf_file, 7, SEEK_CUR);
    value_d020 = getc (vsf_file);
    value_d021 = getc (vsf_file);


    bank = 0xc000 - (value_dd00 & 3) * 0x4000;
    bitmap = ((value_d018 >> 3) & 1) * 0x2000 + bank;
    map = (value_d018 >> 4) * 0x0400 + bank;

    if(hmflag)
    {
        if (!(att_file = fopen (attrib_name, "wb")))
        {
            printf ("Cant't write color attributes file '%s'!\n", attrib_name);
            fclose(vsf_file);
            fclose(map_file);
            fclose(col_file);
            fclose(prg_file);
            return -1;
        };
    }

    LINE;
    printf ("Using %s Bitmap in Bank $%04x ($%02x).\n", (hmflag?"MC":"Hires"), bank, value_dd00);
    printf ("BitMap at $%04x\t\twritten as '%s' without header.\n", bitmap,bitmap_name);
    printf ("ColMap at $%04x ($%02x)\twritten as '%s' without header.\n", map,value_d018, colmap_name);
    if(hmflag)
    {
        printf ("ColAttr at $d800\twritten as '%s' without header.\n", attrib_name);
    }
    printf ("Executable %s-Viewer\twritten as '%s'.\n",(hmflag?"MC":"Hires"),prg_name);
    LINE;

    if(hmflag)
    {
        mbasic[M_PATCH_D020]=value_d020;
        mbasic[M_PATCH_D021]=value_d021;
        fwrite (&mbasic, sizeof (mbasic), 1, prg_file);
        for (i = 0; i < 0x401-sizeof (mbasic); i++)
        {
            putc (0, prg_file);
        }
    }
    else
    {
        fwrite (&basic, sizeof (basic), 1, prg_file);
        for (i = 0; i < 0x401-sizeof (basic); i++)
        {
            putc (0, prg_file);
        }
    }
    fseek (vsf_file, 0x80 + map, SEEK_SET);
    for (i = 0; i < 1000; i++)
    {
        byte = getc (vsf_file);
        putc (byte, col_file);
        putc (byte, prg_file);
    }
    for (i = 0; i < 0x18; i++)
    {
        putc (0, prg_file);
    }

    if(hmflag)
    {
        fseek (vsf_file, pos_d800, SEEK_SET);
        for (i = 0; i < 1000; i++)
        {
            byte = getc (vsf_file); /* byte &=0x0f; not needed */
            putc (byte, att_file);
            putc (byte, prg_file);
        }
        fclose(att_file);
        for (i = 0; i < (0x1000-1000); i++)
        {
            putc (0, prg_file);
        }
    }
    else
    {
        for (i = 0; i < 0x1000; i++)
        {
            putc (0, prg_file);
        }
    }
    fseek (vsf_file, 0x80 + bitmap, SEEK_SET);
    for (i = 0; i < 8000; i++)
    {
        byte = getc (vsf_file);
        putc (byte, map_file);
        putc (byte, prg_file);
    }

    fclose(vsf_file);
    fclose(map_file);
    fclose(col_file);
    fclose(prg_file);

    return 0;
}
